/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VDdLastchangeRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VDdLastchange extends TableImpl<VDdLastchangeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_dd_lastchange</code>
     */
    public static final VDdLastchange V_DD_LASTCHANGE = new VDdLastchange();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDdLastchangeRecord> getRecordType() {
        return VDdLastchangeRecord.class;
    }

    /**
     * The column <code>common_dd.v_dd_lastchange.k</code>.
     */
    public final TableField<VDdLastchangeRecord, Integer> K = createField(DSL.name("k"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dd_lastchange.name</code>.
     */
    public final TableField<VDdLastchangeRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dd_lastchange.lc</code>.
     */
    public final TableField<VDdLastchangeRecord, LocalDateTime> LC = createField(DSL.name("lc"), SQLDataType.LOCALDATETIME(6), this, "");

    private VDdLastchange(Name alias, Table<VDdLastchangeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDdLastchange(Name alias, Table<VDdLastchangeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
         create view "v_dd_lastchange" as  SELECT h.key_element AS k,
            't_core_element_hierarchy'::text AS name,
            h.lastchange AS lc
           FROM common_dd.t_core_element_hierarchy h
        UNION ALL
         SELECT cv.key_variable AS k,
            't_core_variable'::text AS name,
            cv.lastchange AS lc
           FROM common_dd.t_core_variable cv
        UNION ALL
         SELECT iv.fk_variable AS k,
            't_input_variable'::text AS name,
            iv.lastchange AS lc
           FROM common_dd.t_input_variable iv
        UNION ALL
         SELECT vg.fk_key_element AS k,
            't_core_vargrp'::text AS name,
            vg.lastchange AS lc
           FROM common_dd.t_core_vargrp vg
        UNION ALL
         SELECT study.fk_element AS k,
            't_core_study'::text AS name,
            study.lastchange AS lc
           FROM common_dd.t_core_study study
        UNION ALL
         SELECT il.fk_element AS k,
            't_input_label'::text AS name,
            il.lastchange AS lc
           FROM common_dd.t_input_label il
        UNION ALL
         SELECT rg.fk_key_element AS k,
            't_core_repeatgrp'::text AS name,
            rg.lastchange AS lc
           FROM common_dd.t_core_repeatgrp rg
        UNION ALL
         SELECT webform.fk_form AS k,
            't_input_webform'::text AS name,
            webform.lastchange AS lc
           FROM common_dd.t_input_webform webform
        UNION ALL
         SELECT bar.fk_element AS k,
            'logic'::text AS name,
            max(bar.l_lastchange) AS lc
           FROM ( SELECT l.fk_element,
                    GREATEST(l.lastchange, lo.lastchange, la.lastchange, lc.lastchange) AS l_lastchange
                   FROM (((common_dd.vm_core_logicchain_active l
                     LEFT JOIN common_dd.t_core_logicorgrp lo ON ((l.fk_orgrp = lo.orgrp)))
                     LEFT JOIN common_dd.t_core_logicandgrp la ON ((la.fk_orgrp = lo.orgrp)))
                     LEFT JOIN common_dd.t_core_logiccond lc ON ((lc.fk_andgrp = la.andgrp)))) bar
          GROUP BY bar.fk_element
        UNION ALL
         SELECT bar.key_variable AS k,
            'valuelist'::text AS name,
            max(bar.vl_lastchange) AS lc
           FROM ( SELECT v.key_variable,
                    GREATEST(v.lastchange, vl.lastchange, val.lastchange, vp.lastchange, tk.lastchange, t.lastchange) AS vl_lastchange
                   FROM (((((common_dd.t_core_variable v
                     LEFT JOIN common_dd.t_core_valuelist vl ON ((v.fk_var_valuelist = vl.valuelist)))
                     LEFT JOIN common_dd.t_core_value val ON ((vl.valuelist = val.fk_value_valuelist)))
                     LEFT JOIN common_dd.t_core_valueparam vp ON ((vp.fk_valueparam_value = val.pk_core_value)))
                     LEFT JOIN common_dd.t_core_translation_key tk ON ((vp.param_key = tk.translation_key)))
                     LEFT JOIN common_dd.t_core_translation t ON ((tk.translation_key = t.fk_trans_key)))) bar
          GROUP BY bar.key_variable
        UNION ALL
         SELECT bar.key_element AS k,
            'translation'::text AS name,
            max(bar.t_lastchange) AS lc
           FROM ( SELECT h.key_element,
                    GREATEST(tk.lastchange, t.lastchange) AS t_lastchange
                   FROM ((common_dd.t_core_element_hierarchy h
                     LEFT JOIN common_dd.t_core_translation_key tk ON ((h.hier_lang = tk.translation_key)))
                     LEFT JOIN common_dd.t_core_translation t ON ((tk.translation_key = t.fk_trans_key)))) bar
          GROUP BY bar.key_element;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_dd_lastchange</code> table reference
     */
    public VDdLastchange(String alias) {
        this(DSL.name(alias), V_DD_LASTCHANGE);
    }

    /**
     * Create an aliased <code>common_dd.v_dd_lastchange</code> table reference
     */
    public VDdLastchange(Name alias) {
        this(alias, V_DD_LASTCHANGE);
    }

    /**
     * Create a <code>common_dd.v_dd_lastchange</code> table reference
     */
    public VDdLastchange() {
        this(DSL.name("v_dd_lastchange"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VDdLastchange as(String alias) {
        return new VDdLastchange(DSL.name(alias), this);
    }

    @Override
    public VDdLastchange as(Name alias) {
        return new VDdLastchange(alias, this);
    }

    @Override
    public VDdLastchange as(Table<?> alias) {
        return new VDdLastchange(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDdLastchange rename(String name) {
        return new VDdLastchange(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDdLastchange rename(Name name) {
        return new VDdLastchange(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDdLastchange rename(Table<?> name) {
        return new VDdLastchange(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDdLastchange where(Condition condition) {
        return new VDdLastchange(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDdLastchange where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDdLastchange where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDdLastchange where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDdLastchange where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDdLastchange where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDdLastchange where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDdLastchange where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDdLastchange whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDdLastchange whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
